%% GAMMAS
%function [x1 x2 x3 creal a1 a2 a3 b1 b2 b3]=generate_gammas_vus(vus,n1,n2,n3)
close all
clc
vuss=0.7;
 
%J=0.4
 if vuss==0.3
 a1=2;b1=5;a2=2.5;b2=5;a3=3.1855;b3=5;
 elseif vuss==0.5
 a1=2;b1=5;a2=3.5;b2=5;a3=5.1399;b3=5;
 elseif vuss==0.7
 a1=2;b1=5;a2=4.5;b2=5;a3=7.8557;b3=5;
 end
%keep the original generated data at xors:

% x1=gamrnd(a1,b1,n1,1);
% x2=gamrnd(a2,b2,n2,1);
% x3=gamrnd(a3,b3,n3,1);


F1=@(x) gamcdf(x,a1,b1);
F2=@(x) gamcdf(x,a2,b2);
F3=@(x) gamcdf(x,a3,b3);

f1=@(x) gampdf(x,a1,b1);
f2=@(x) gampdf(x,a2,b2);
f3=@(x) gampdf(x,a3,b3);
 gr=0:0.01:30;
 plot(gr,f1(gr),'b')
 hold on
 plot(gr,f2(gr),'g')
 plot(gr,f3(gr),'r')



Jh=@(g) -0.5*(F1(g(1))-F2(g(1))+F2(g(2))-F3(g(2)));
[creal Jreal]=fminsearch(Jh,[2 3]);

ROCsurf =@(p1,p3) (gaminv(1-p3,a3,b3)>gaminv(p1,a1,b1)).*(gamcdf(gaminv(1-p3,a3,b3),a2,b2)-gamcdf(gaminv(p1,a1,b1),a2,b2));


realvus=dblquad(ROCsurf,0,1,0,1);
vustrue=realvus;
vustrue
%end
%% LOGNORMALS

%function [x1 x2 x3 creal a1 a2 a3 b1 b2 b3]=generate_gammas_vus(vus,n1,n2,n3)
close all
clc
vuss=0.7;
%J=0.4
 if vuss==0.3
 a1=2;b1=0.5;a2=2.2;b2=0.5;a3=2.402;b3=0.5;
 elseif vuss==0.5
 a1=2;b1=0.5;a2=2.4;b2=0.5;a3=2.912;b3=0.5;
 elseif vuss==0.7
 a1=2;b1=0.5;a2=2.7;b2=0.5;a3=3.4571;b3=0.5;
%  a1=2;b1=0.6;a2=2;b2=0.6;a3=2;b3=0.6

 end
%keep the original generated data at xors:

% x1=normrnd(a1,b1,n1,1);
% x2=normrnd(a2,b2,n2,1);
% x3=normrnd(a3,b3,n3,1);
% 

F1=@(x) logncdf(x,a1,b1);
F2=@(x) logncdf(x,a2,b2);
F3=@(x) logncdf(x,a3,b3);

f1=@(x) lognpdf(x,a1,b1);
f2=@(x) lognpdf(x,a2,b2);
f3=@(x) lognpdf(x,a3,b3);
gr=0:0.01:30;
plot(gr,f1(gr),'b')
hold on
plot(gr,f2(gr),'g')
plot(gr,f3(gr),'r')



Jh=@(g) -0.5*(F1(g(1))-F2(g(1))+F2(g(2))-F3(g(2)));
[creal J]=fminsearch(Jh,[2 3]);

m1=a1;
s1=b1;
m2=a2;
s2=b2;
m3=a3;
s3=b3;

ROCsurf=@(p1,p3) (logninv(1-p3,m3,s3)>logninv(p1,m1,s1)).*(logncdf(logninv(1-p3,m3,s3),m2,s2)-...
      logncdf(logninv(p1,m1,s1),m2,s2));


realvus=dblquad(ROCsurf,0,1,0,1)
vustrue=realvus;
vustrue



%% NORMALS

%function [x1 x2 x3 creal a1 a2 a3 b1 b2 b3]=generate_gammas_vus(vus,n1,n2,n3)
close all
clc
vuss=0.5;
%J=0.4
 if vuss==0.3
 a1=7;b1=1;a2=7.4;b2=1;a3=7.804;b3=1;
 elseif vuss==0.5
 a1=7;b1=1;a2=8;b2=1;a3=8.821;b3=1;
 elseif vuss==0.7
 a1=7;b1=1;a2=8.5;b2=1;a3=9.9137;b3=1;
%  a1=2;b1=0.6;a2=2;b2=0.6;a3=2;b3=0.6

 end
%keep the original generated data at xors:

% x1=normrnd(a1,b1,n1,1);
% x2=normrnd(a2,b2,n2,1);
% x3=normrnd(a3,b3,n3,1);
% 

F1=@(x) normcdf(x,a1,b1);
F2=@(x) normcdf(x,a2,b2);
F3=@(x) normcdf(x,a3,b3);

f1=@(x) normpdf(x,a1,b1);
f2=@(x) normpdf(x,a2,b2);
f3=@(x) normpdf(x,a3,b3);
gr=0:0.01:30;
plot(gr,f1(gr),'b')
hold on
plot(gr,f2(gr),'g')
plot(gr,f3(gr),'r')



Jh=@(g) -0.5*(F1(g(1))-F2(g(1))+F2(g(2))-F3(g(2)));
[creal J]=fminsearch(Jh,[2 3]);

m1=a1;
s1=b1;
m2=a2;
s2=b2;
m3=a3;
s3=b3;

ROCsurf=@(p1,p3) (norminv(1-p3,m3,s3)>norminv(p1,m1,s1)).*(normcdf(norminv(1-p3,m3,s3),m2,s2)-...
      normcdf(norminv(p1,m1,s1),m2,s2));


realvus=dblquad(ROCsurf,0,1,0,1)
vustrue=realvus;
vustrue



%% MIXTURE

%function [x1 x2 x3 creal a1 a2 a3 b1 b2 b3]=generate_gammas_vus(vus,n1,n2,n3)
close all
vuss=0.7;
n=10000;
n1=n;n2=n;n3=n;
%J=0.4
 if vuss==0.3
 a1=7;b1=1;a2=7.5;b2=1;m3a=7.5;s3a=1;m3b=10;s3b=1;
 elseif vuss==0.5
     kk=0.9;
 a1=7;b1=1;a2=7.4;b2=1;m3a=7.5+kk;s3a=1;m3b=11+kk;s3b=1;
 elseif vuss==0.7
     kk=1.9;
 a1=7;b1=1;a2=8.3;b2=1;m3a=7.5+kk;s3a=1;m3b=11+kk;s3b=1;
 end
%keep the original generated data at xors:
u=rand(n3,1);
x1=normrnd(a1,b1,n1,1);
x2=normrnd(a2,b2,n2,1);
x3=(u>0.5).*normrnd(m3a,s3a,n3,1)+(u<=0.5).*normrnd(m3b,s3b,n3,1);

h1=0.9*min(std(x1),iqr(x1)/1.34)*length(x1)^(-0.2);
h2=0.9*min(std(x2),iqr(x2)/1.34)*length(x2)^(-0.2);
h3=0.9*min(std(x3),iqr(x3)/1.34)*length(x3)^(-0.2);
h1a=h1;h1b=h2;h1c=h3;
W1a=x1;W1b=x2;W1c=x3;


F1=@(x) normcdf(x,a1,b1);
F2=@(x) normcdf(x,a2,b2);
F3=@(x) 0.5.*normcdf(x,m3a,s3a)+0.5.*normcdf(x,m3b,s3b);

f1=@(x) normpdf(x,a1,b1);
f2=@(x) normpdf(x,a2,b2);
f3=@(x) 0.5.*normpdf(x,m3a,s3a)+0.5.*normpdf(x,m3b,s3b);
gr=0:0.05:30;
plot(gr,f1(gr),'b')
hold on
plot(gr,f2(gr),'g')
plot(gr,f3(gr),'r')


figure
plot(gr,log(f3(gr)./f2(gr)),'r')
hold on
plot(gr,log(f2(gr)./f1(gr)),'b')


Jh=@(g) -0.5*(F1(g(1))-F2(g(1))+F2(g(2))-F3(g(2)));
[creal J]=fminsearch(Jh,[2 3]);

m1=a1;
s1=b1;
m2=a2;
s2=b2;
m3=a3;
s3=b3;
    Finv1ahat=@(t) ksdensity(W1a,t,'width',h1a,'function','icdf');
    Finv1chat=@(t) ksdensity(W1c,1-t,'width',h1c,'function','icdf');
    F1bhat=@(x) normcdf(x,m2,s2);

ROC1point=@(p1,p3) (Finv1chat(1-p3)>Finv1ahat(p1)).*(F1bhat(Finv1chat(1-p3))-F1bhat(Finv1ahat(p1)));
grt=0:0.03:1;
[pp1,pp3] = meshgrid(grt, grt);
p1=pp1(1:end)';
p3=pp3(1:end)';
rr1=ROC1point(p1,p3);

p1=reshape(p1,size(pp1,1),size(pp1,2));
p3=reshape(p3,size(pp3,1),size(pp3,2));
rr1=reshape(rr1,size(pp1,1),size(pp1,2));
figure
surf(p1,p3,rr1)
vus1=trapz((grt)',trapz((grt)',rr1,2),1)
vus1
%end

Jh=@(g) -0.5*(F1(g(1))-F2(g(1))+F2(g(2))-F3(g(2)));
[creal J]=fminsearch(Jh,[0.5*(mean(x1)+mean(x2)) 0.5*(mean(x2)+mean(x3))]);

%% LOGNORMALS

%function [x1 x2 x3 creal a1 a2 a3 b1 b2 b3]=generate_logn_vus(vus,n1,n2,n3)
close all
vuss=0.3;
%J=0.4
 if vuss==0.3
  a1=2;b1=0.6;a2=2.;b2=0.6;a3=2.;b3=0.6
 elseif vuss==0.5
  a1=2;b1=0.6;a2=2.3;b2=0.55;a3=2.4975;b3=0.5
 elseif vuss==0.7
  a1=2;b1=0.6;a2=2.5;b2=0.55;a3=3.002;b3=0.5
 end
%keep the original generated data at xors:

x1=lognrnd(a1,b1,n1,1);
x2=lognrnd(a2,b2,n2,1);
x3=lognrnd(a3,b3,n3,1);


F1=@(x) logncdf(x,a1,b1);
F2=@(x) logncdf(x,a2,b2);
F3=@(x) logncdf(x,a3,b3);

f1=@(x) lognpdf(x,a1,b1);
f2=@(x) lognpdf(x,a2,b2);
f3=@(x) lognpdf(x,a3,b3);
 gr=0:0.01:30;
 plot(gr,f1(gr),'b')
 hold on
 plot(gr,f2(gr),'g')
 plot(gr,f3(gr),'r')


Jh=@(g) -0.5*(F1(g(1))-F2(g(1))+F2(g(2))-F3(g(2)));
[creal J]=fminsearch(Jh,[2 3]);

ROCsurf=@(p1,p3) (logninv(1-p3,a3,b3)>logninv(p1,a1,b1)).*(logncdf(logninv(1-p3,a3,b3),a2,b2)-...
      logncdf(logninv(p1,b1,b1),a2,b2));


realvus=dblquad(ROCsurf,0,1,0,1);
vustrue=realvus;
vustrue
%end


