function [Jhat, vus, outvolume, outrect, marginalCIs, deltas, TC123, covdeltas, cutoffs, covdeltas_plot, FCboots]=fkernelsegg(x1,x2,x3,gridd)
aa=0;
    aa=aa+1;
    rand('twister', 5493+aa);
      randn('state', 3+aa);
      randn('seed',3+aa);
      rand('seed',3+aa);

%----Estimation Procedure:
n1=length(x1);n2=length(x2);n3=length(x3);
xor1=x1;xor2=x2;xor3=x3;

az = -135.5000;
el = 30;
%xor1=normrnd(8,1,1000,1);xor2=xor1;xor3=xor1;
%xor1=normrnd(8,1,1000,1);xor2=xor1+10;xor3=xor1+20;


x1=xor1;x2=xor2;x3=xor3;
[transx1, transx2, transx3, lam, exitflag]=boxcox3d(x1,x2,x3);
x1=transx1;x2=transx2;x3=transx3;


% h1=0.9*min(std(xor1),iqr(xor1)/1.34)*length(xor1)^(-0.2);
% h2=0.9*min(std(xor2),iqr(xor2)/1.34)*length(xor2)^(-0.2);
% h3=0.9*min(std(xor3),iqr(xor3)/1.34)*length(xor3)^(-0.2);




%Monte Carlo
F1hat=@(g) mykernel(x1,g);
F2hat=@(g) mykernel(x2,g);
F3hat=@(g) mykernel(x3,g);

%x: P(X<c1), y:P(X>c2), z=P(c1<X<c2), c1<c2
%x: F1, y: 1-F3, z: F2(c2)-F2(c1)
cc=gridd;
[pp1,pp3] = meshgrid(cc, cc);
 p1or=pp1;p3or=pp3;
 pp1=pp1(1:end)';pp3=pp3(1:end)';
 
ROCk= (F2hat(pp3)-F2hat(pp1)).*(pp3>pp1);
p1=F1hat(pp1);p3=1-F3hat(pp3);


ss1=reshape(p1,size(p1or,1),size(p1or,2));
ss3=reshape(p3,size(p3or,1),size(p3or,1));
RR=reshape(ROCk,size(p3or,1),size(p3or,2));



%subplot(1,2,1)
title('KernelBC')

%ss1(RR<=0)=[0];ss3(RR<=0)=[0];RR(RR<=0)=[0];


surf(ss1,ss3,RR) %plot the ROC surface

view(az,el)
xlabel('x');ylabel('y');zlabel('z');
shading interp
alpha(0.8)

bbb=[ss1(1:end)' ss3(1:end)' RR(1:end)'];
%atnan=find(isnan(bbb(:,1))==1);

bbb=[bbb;[0 0 0];[0 0 1]];
%bbb=[bbb];

[volumekernel,area]=area3d(bbb)

%error('hgjg')

J=@(k) -(F1hat(k(1))-F2hat(k(1))+F2hat(k(2))-F3hat(k(2)))
[chat gval exitflag]=fminsearch(J,[(mean(x1)+mean(x2))/2 (mean(x2)+mean(x3))/2])
chator=chat

Jhatkernel = -0.5*gval

    Se1=F1hat(chat(1));
    Se2=F2hat(chat(2))-F2hat(chat(1)); 
    Se3=1-F3hat(chat(2));

    delta1 =norminv(Se1);%log(Se1/(1-Se1));
    delta2 =norminv(Se2);%log(Se2/(1-Se2));
    delta3 =norminv(Se3);%log(Se3/(1-Se3));
    
    
delta1hat=norminv(Se1);%log(Se1/(1-Se1));
delta2hat=norminv(Se2);%log(Se2/(1-Se2));
delta3hat=norminv(Se3);%log(Se3/(1-Se3));
Se123hat=[Se1 Se2 Se3];
%[c1gr c2gr]= meshgrid(-20:0.1:20,-20:0.1:20);

hold on



boots=1;
while boots<=400
boots

    at1=randsample(1:n1,n1,'true');
    at2=randsample(1:n2,n2,'true');
    at3=randsample(1:n3,n3,'true');
    
x1=xor1(at1);x2=xor2(at2);x3=xor3(at3);
[transx1, transx2, transx3, lam, exitflag]=boxcox3d(x1,x2,x3);
x1=transx1;x2=transx2;x3=transx3;

%e=mvnrnd([0 0 0],diag([h1^2 h2^2 h3^2]),max(max(n1,n2),n3));
%e1=e(:,1);e2=e(:,2);e3=e(:,3);

F1hat=@(g) mykernel(x1,g);
F2hat=@(g) mykernel(x2,g);
F3hat=@(g) mykernel(x3,g);

J=@(k) -(F1hat(k(1))-F2hat(k(1))+F2hat(k(2))-F3hat(k(2)));
[chat gval exitflag]=fminsearch(J,[(mean(x1)+mean(x2))/2 (mean(x2)+mean(x3))/2]);
chatb1(boots)=chat(1);c1b=chat(1);c2b=chat(2);
chatb2(boots)=chat(2);
Jhatkb(boots)=-0.5*gval;


if chat(1)<chat(2) && chat(1)~=0 && chat(2)~=0

    
    Se1=F1hat(chat(1));
    Se2=F2hat(chat(2))-F2hat(chat(1)); 
    Se3=1-F3hat(chat(2));

    
   F21b(boots) = F1hat(c2b)-F1hat(c1b);
   F31b(boots) = 1-F1hat(c2b);
   F12b(boots) = F2hat(c1b);
   F32b(boots) = 1-F2hat(c2b);
   F13b(boots) = F3hat(c1b);
   F23b(boots) = F3hat(c2b)-F3hat(c1b);



    Se1b(boots)=Se1;Se2b(boots)=Se2;Se3b(boots)=Se3;
        
    bdelta1(boots)=norminv(Se1);
    bdelta2(boots)=norminv(Se2);
    bdelta3(boots)=norminv(Se3);
    boots=boots+1;
    if sum(abs(bdelta1))==Inf || sum(abs(bdelta2))==Inf || sum(abs(bdelta3))==Inf
        boots=boots-1;
        flagme=flagme+1;
    end
    
else 
    boots=boots;
end
end

if size(F21b,1)==1;F21b=F21b';F31b=F31b';F12b=F12b';F32b=F32b';F13b=F13b';F23b=F23b';end
FCboots=[F21b F31b F12b F32b F13b F23b];

JCIkernels    =[Jhatkernel-1.96*sqrt(var(Jhatkb)) Jhatkernel+1.96*sqrt(var(Jhatkb))];
%start dealing with q perc 

covdeltas=cov([bdelta1' bdelta3' bdelta2']);
covnew=cov([bdelta1' bdelta2' bdelta3']);



bcov11 =covdeltas(1,1);
bcov12 =covdeltas(1,2);
bcov13 =covdeltas(1,3);
bcov21 =covdeltas(2,1);
bcov22 =covdeltas(2,2);
bcov23 =covdeltas(2,3);
bcov31 =covdeltas(3,1);
bcov32 =covdeltas(3,2);
bcov33 =covdeltas(3,3);


       
invcovdeltas=inv(covdeltas);
[U D V]=svd(invcovdeltas);
covdeltas_plot=covdeltas;

%a=sqrt(5.99)/sqrt(D(1,1));
%b=sqrt(5.99)/sqrt(D(2,2));
% 
% a=sqrt(chi2inv(0.95,3))/sqrt(D(1,1));
% b=sqrt(chi2inv(0.95,3))/sqrt(D(3,3));
% c=sqrt(chi2inv(0.95,3))/sqrt(D(2,2));


shading interp
alpha(0.8)
%close all
axis([0 1 0 1 0 1])
hold on
%C=[mean(bdelta1) mean(bdelta3) mean(bdelta2)]';
C=[delta1hat delta3hat delta2hat]';
aaaainvcovdeltas=invcovdeltas
aaaC=C
[K1 K2 K3 SS]=myellipsoid(invcovdeltas, C, 20);
alpha(0.2)
xlabel('TC_{1}')
ylabel('TC_{3}')
zlabel('TC_{2}')



alpha(0.8)
hold on



xyz = SS;
 [tess vol_egg] = convhulln(SS);
 volegg =vol_egg;

 %current_coverage=mean(in)
 
 
 %deal with the cube:
 tpr1ci=[delta1hat-norminv(0.9916,0,1)*sqrt(covdeltas(1,1)) delta1hat+norminv(0.9916,0,1)*sqrt(covdeltas(1,1))]; 
 tpr3ci=[delta3hat-norminv(0.9916,0,1)*sqrt(covdeltas(2,2)) delta3hat+norminv(0.9916,0,1)*sqrt(covdeltas(2,2))];
 tpr2ci=[delta2hat-norminv(0.9916,0,1)*sqrt(covdeltas(3,3)) delta2hat+norminv(0.9916,0,1)*sqrt(covdeltas(3,3))];

 CI1=[normcdf(tpr1ci(1)), normcdf(tpr1ci(2))];%[invlogit(tpr1ci(1)), invlogit(tpr1ci(2))];
 CI3=[normcdf(tpr3ci(1)), normcdf(tpr3ci(2))];%[invlogit(tpr3ci(1)), invlogit(tpr3ci(2))];
 CI2=[normcdf(tpr2ci(1)), normcdf(tpr2ci(2))];%[invlogit(tpr2ci(1)), invlogit(tpr2ci(2))];
 
 drawrect( [CI1(1) CI3(1) CI2(1)], [CI1(2)-CI1(1) abs(CI3(2)-CI3(1)) CI2(2)-CI2(1)] );
 alpha(0.7)
 volrect =abs(CI1(2)-CI1(1))*abs(CI2(2)-CI2(1))*abs(CI3(2)-CI3(1));
%title('Kernel qq smooth')

%=======UNIVARIATE

tpr1ci=[delta1hat-norminv(0.975,0,1)*sqrt(covdeltas(1,1)) delta1hat+norminv(0.975,0,1)*sqrt(covdeltas(1,1))]; 
 tpr3ci=[delta3hat-norminv(0.975,0,1)*sqrt(covdeltas(2,2)) delta3hat+norminv(0.975,0,1)*sqrt(covdeltas(2,2))];
 tpr2ci=[delta2hat-norminv(0.975,0,1)*sqrt(covdeltas(3,3)) delta2hat+norminv(0.975,0,1)*sqrt(covdeltas(3,3))];

 CI1marg=[normcdf(tpr1ci(1)), normcdf(tpr1ci(2))];%[invlogit(tpr1ci(1)), invlogit(tpr1ci(2))];
 CI3marg=[normcdf(tpr3ci(1)), normcdf(tpr3ci(2))];%[invlogit(tpr3ci(1)), invlogit(tpr3ci(2))];
 CI2marg=[normcdf(tpr2ci(1)), normcdf(tpr2ci(2))];%[invlogit(tpr2ci(1)), invlogit(tpr2ci(2))];

 

Jhat=Jhatkernel;
vus=volumekernel%dblquad(ROCsurf,0,1,0,1);
outvolume=[volegg volrect];
outrect=[CI1; CI2; CI3];
marginalCIs=[CI1marg;CI2marg;CI3marg];
covdeltas=covnew;
deltas=[delta1 delta2 delta3];
TC123=Se123hat;
cutoffs=[chat(1) chat(2)];

end
