function [x1 x2 x3 creal a1 a2 a3 b1 b2 b3]=generate_gammas(J,n1,n2,n3)


if J==0.4
a1=1.385;b1=2;a2=3;b2=2;a3=4.615;b3=2;
elseif J==0.6
a1=2.87;b1=2;a2=7;b2=2;a3=11.13;b3=2;
elseif J==0.8
a1=2;b1=2;a2=9;b2=2;a3=16;b3=2;
end
%keep the original generated data at xors:
x1=gamrnd(a1,b1,n1,1);
x2=gamrnd(a2,b2,n2,1);
x3=gamrnd(a3,b3,n3,1);


F1=@(x) gamcdf(x,a1,b1);
F2=@(x) gamcdf(x,a2,b2);
F3=@(x) gamcdf(x,a3,b3);


Jh=@(g) -0.5*(F1(g(1))-F2(g(1))+F2(g(2))-F3(g(2)));
[creal J]=fminsearch(Jh,[2 3]);



end
