

close all
clear all
clc

%200, 5-6-7 super!
%100, 5-6-7
epan=1;
tic
warn=0;
aa=0;
while epan<=1000
    aa=aa+1;
    rand('twister', 5493+aa);
      randn('state', 3+aa); 
      randn('seed',3+aa);
      rand('seed',3+aa);

    epan
    close all
    
    
n=200;n1=n;n2=n;n3=n;
%n1=50;n2=100;n3=200;
%J=0.6;Jreal=J;
n1=n;n2=n;n3=n;
[x1 x2 x3 creal a1 a2 a3 b1 b2 b3 vuss]=generate_gammas_vus(0.7,n1,n2,n3)
% a1=1.385;b1=2;a2=3.8995;b2=2;a3=8.043;b3=2;
x1=gamrnd(a1,b1,n1,1);
x2=gamrnd(a2,b2,n2,1);
x3=gamrnd(a3,b3,n3,1);

%keep the original generated data at xors:
xor1=x1;xor2=x2;xor3=x3;
c1real=creal(1);
c2real=creal(2);
%Jreal=0.4;%0.5*(normcdf((c1real-m1)/s1)-normcdf((c1real-m2)/s2)+normcdf((c2real-m2)/s2)-normcdf((c2real-m3)/s3))
%Jreal
%break
true1=gamcdf(c1real,a1,b1);
true2=gamcdf(c2real,a2,b2)-gamcdf(c1real,a2,b2);
true3=1-gamcdf(c2real,a3,b3);


TC1true=true1;
TC2true=true2;
TC3true=true3;
FC21true=gamcdf(c2real,a1,b1)-gamcdf(c1real,a1,b1);
FC31true=1-gamcdf(c2real,a1,b1);
FC12true=gamcdf(c1real,a2,b2);
FC32true=1-gamcdf(c2real,a2,b2);
FC13true=gamcdf(c1real,a3,b3);
FC23true=gamcdf(c2real,a3,b3)-gamcdf(c1real,a3,b3);

F21true=FC21true;
F31true=FC31true;
F12true=FC12true;
F32true=FC32true;
F13true=FC13true;
F23true=FC23true;


truedelta1=norminv(TC1true);
truedelta2=norminv(TC2true);
truedelta3=norminv(TC3true);

trueop=[true1 true2 true3];%this will change at the end since the actual point is true1, true3, true2
ROCsurf=@(p1,p3) (gaminv(1-p3,m3,s3)>gaminv(p1,m1,s1)).*(gamcdf(gaminv(1-p3,m3,s3),m2,s2)-...
      gamcdf(gaminv(p1,m1,s1),m2,s2));


%----Estimation Procedure:

n1=length(x1);n2=length(x2);n3=length(x3); status1=zeros(n1,1);status2=zeros(n2,1);status3=zeros(n3,1);

[bhat H1 F1hat S1 KMdist knots gcoxhat]=HCNS(x1, status1, 0, [], 'auto',2,[]  );
[bhat H2 F2hat S2 KMdist knots gcoxhat]=HCNS(x2, status2, 0, [], 'auto',2,[]  );
[bhat H3 F3hat S3 KMdist knots gcoxhat]=HCNS(x3, status3, 0, [], 'auto',2,[]  );

init1=0.5*(mean(x1)+mean(x2));
init2=0.5*(mean(x2)+mean(x3));

Jhat=@(g) -0.5*(F1hat(g(1))-F2hat(g(1))+F2hat(g(2))-F3hat(g(2)));
[chat Jhat]=fminsearch(Jhat,[init1 init2])
c1hat=chat(1);
c2hat=chat(2);

TC1hat=F1hat(c1hat);
TC2hat=F2hat(c2hat)-F2hat(c1hat);
TC3hat=1-F3hat(c2hat);


F21 = F1hat(c2hat)-F1hat(c1hat);
F31 = 1-F1hat(c2hat);

F12 = F2hat(c1hat);
F32 = 1-F2hat(c2hat);

F13 = F3hat(c1hat)
F23 = F3hat(c2hat)-F3hat(c1hat);

 %==========================
norminvF21 = norminv(F21);
norminvF31 = norminv(F31);
norminvF12 = norminv(F12);
norminvF32 = norminv(F32);
norminvF13 = norminv(F13);
norminvF23 = norminv(F23);

TC1hat= F1hat(c1hat);
TC2hat= F2hat(c2hat)-F2hat(c1hat);
TC3hat= 1-F3hat(c2hat);


%=================START BOOTSTRAP=============================
boots=1;
while boots<=400
    epan
    boots
at1=randsample(1:n1,n1,'true');   
at2=randsample(1:n2,n2,'true');
at3=randsample(1:n3,n3,'true');

x1boots=x1(at1);
x2boots=x2(at2);
x3boots=x3(at3);

[bhat H1 F1b S1 KMdist knots gcoxhat]=HCNS(x1boots, status1, 0, [], 'auto',2,[]  );
[bhat H2 F2b S2 KMdist knots gcoxhat]=HCNS(x2boots, status2, 0, [], 'auto',2,[]  );
[bhat H3 F3b S3 KMdist knots gcoxhat]=HCNS(x3boots, status3, 0, [], 'auto',2,[]  );
if isa(F1b,'function_handle')==1 && isa(F2b,'function_handle')==1 && isa(F3b,'function_handle')==1
    
Jb=@(g) -0.5*(F1b(g(1))-F2b(g(1))+F2b(g(2))-F3b(g(2)));
init1=0.5*(mean(x1boots)+mean(x2boots));
init2=0.5*(mean(x2boots)+mean(x3boots));

[cb Jb]=fminsearch(Jb,[init1 init2])
c1b=cb(1);
c2b=cb(2);

F21b(boots) = F1b(c2b)-F1b(c1b);
F31b(boots) = 1-F1b(c2b);
F12b(boots) = F2b(c1b);
F32b(boots) = 1-F2b(c2b);
F13b(boots) = F3b(c1b);
F23b(boots) = F3b(c2b)-F3b(c1b);

TC1b(boots)= F1b(c1b);
TC2b(boots)= F2b(c2b)-F2b(c1b);
TC3b(boots)= 1-F3b(c2b);

FCb=[F21b(boots);F31b(boots);F12b(boots);F32b(boots);F13b(boots);F23b(boots)]
if min(FCb)>0 && max(FCb)<1
boots=boots+1;
end
end

end

if size(F21b,1)==1;F21b=F21b';end
if size(F31b,1)==1;F31b=F31b';end
if size(F12b,1)==1;F12b=F12b';end
if size(F32b,1)==1;F32b=F32b';end
if size(F13b,1)==1;F13b=F13b';end
if size(F23b,1)==1;F23b=F23b';end

if size(TC1b,1)==1;TC1b=TC1b';end
if size(TC2b,1)==1;TC2b=TC2b';end
if size(TC3b,1)==1;TC3b=TC3b';end

fcinvall=[norminv(F21b) norminv(F31b) norminv(F12b) norminv(F32b) norminv(F13b) norminv(F23b)];
covinvall=cov([fcinvall]);

%=====END BOOTSTRAP=============================









cov_invF21_F31= covinvall(1,2);
cov_invF12_F32= covinvall(3,4);
cov_invF13_F23= covinvall(5,6);

var_invTC1= covinvall(1,1);
var_invTC2= covinvall(1,1);
var_invTC3= covinvall(1,1);

var_invF21= covinvall(1,1);
var_invF31= covinvall(2,2);
var_invF12= covinvall(3,3);
var_invF32= covinvall(4,4);
var_invF13= covinvall(5,5);
var_invF23= covinvall(6,6);

%===end the bootstrap====
CI21inv=[norminvF21-1.96*sqrt(var_invF21) norminvF21+1.96*sqrt(var_invF21)];
CI31inv=[norminvF31-1.96*sqrt(var_invF31) norminvF31+1.96*sqrt(var_invF31)];
CI12inv=[norminvF12-1.96*sqrt(var_invF12) norminvF12+1.96*sqrt(var_invF12)];
CI32inv=[norminvF32-1.96*sqrt(var_invF32) norminvF32+1.96*sqrt(var_invF32)];
CI13inv=[norminvF13-1.96*sqrt(var_invF13) norminvF13+1.96*sqrt(var_invF13)];
CI23inv=[norminvF23-1.96*sqrt(var_invF23) norminvF23+1.96*sqrt(var_invF23)];

CI21=normcdf(CI21inv)
CI31=normcdf(CI31inv)
CI12=normcdf(CI12inv)
CI32=normcdf(CI32inv)
CI13=normcdf(CI13inv)
CI23=normcdf(CI23inv)

TCI1inv=[norminv(TC1hat)-1.96*sqrt(var(norminv(TC1b))) norminv(TC1hat)+1.96*sqrt(var(norminv(TC1b)))];
TCI2inv=[norminv(TC2hat)-1.96*sqrt(var(norminv(TC2b))) norminv(TC2hat)+1.96*sqrt(var(norminv(TC2b)))];
TCI3inv=[norminv(TC3hat)-1.96*sqrt(var(norminv(TC3b))) norminv(TC3hat)+1.96*sqrt(var(norminv(TC3b)))];

TCI1=normcdf(TCI1inv)
TCI2=normcdf(TCI2inv)
TCI3=normcdf(TCI3inv)



   subplot(2,4,5:6)

for i=1:3

if i==1
covdeltas=[var_invF21 cov_invF21_F31;cov_invF21_F31 var_invF31];
plot(F21, F31,'*b','LineWidth',2)
xlabel('F_{2|1}');ylabel('F_{3|1}')
xc1=norminvF21;
xc2=norminvF31;
elseif i==2
    hold on
    
covdeltas=[var_invF12 cov_invF12_F32;cov_invF12_F32 var_invF32];
plot(F12, F32,'*g','LineWidth',2)
xlabel('F_{1|2}');ylabel('F_{3|2}')
xc1=norminvF12;
xc2=norminvF32;
elseif i==3
covdeltas=[var_invF13 cov_invF13_F23;cov_invF13_F23 var_invF23];
plot(F13, F23,'*r','LineWidth',2)
xlabel('F_{1|3}');ylabel('F_{2|3}')
xc1=norminvF13;
xc2=norminvF23;
end  
hold on
    



invcovdeltas=inv(covdeltas);
[U, D, V]=svd(invcovdeltas);

a=sqrt(5.99)/sqrt(D(1,1));
b=sqrt(5.99)/sqrt(D(2,2));

theta=[0:1/40:2*pi+1/40];
state(1,:) = a*cos(theta); 
state(2,:) = b*sin(theta);
X = V * state;
X(1,:) = X(1,:) + xc1;
X(2,:) = X(2,:) + xc2;


%----Area egg---------------
yegg=normcdf(X(2,:))';
xegg=normcdf(X(1,:))';
xegg=[xegg;xegg(1)];yegg=[yegg;yegg(1)];
areaegg= polyarea(xegg,yegg)
hold on
if i==1;xegg1=xegg;yegg1=yegg;plot(xegg,yegg,'b','LineWidth',2);end
if i==2;xegg2=xegg;yegg2=yegg;plot(xegg,yegg,'g','LineWidth',2);end
if i==3;xegg3=xegg;yegg3=yegg;plot(xegg,yegg,'r','LineWidth',2);end

xlim([0 1]);ylim([0 1])
%----End Area egg---------------
end

      legend('Youden estimated FC point (x,y): (F_{2|1}, F_{3|1})',...
             '95% confidence region for (x,y): (F_{2|1}, F_{3|1})',...
             'Youden estimated FC point (x,y): (F_{1|2}, F_{3|2})',...
             '95% confidence region for (x,y): (F_{1|2}, F_{3|2})',...
             'Youden estimated FC point (x,y): (F_{1|3}, F_{2|3})',...
             '95% confidence region for (x,y): (F_{1|3}, F_{2|3})')

         xlabel('F_{i|j}');ylabel('F_{k|j}')

         
      
h = fill(xegg1,yegg1,'b');set(h,'facealpha',.5);
h = fill(xegg2,yegg2,'g');set(h,'facealpha',.5);
h = fill(xegg3,yegg3,'r');set(h,'facealpha',.5);

box on
%axis square

 CIFC=[CI21;
       CI31;
       CI12;
       CI32;
       CI13;
       CI23]
  %subplot(2,4,5:6)
  subplot(2,4,2)
  
%[Jhat, vus, outvolume, outrect, marginalCIs, deltas, TC123, covdeltas, cutoffs, covdeltas_plot]=fbcegg(x1,x2,x3)
%[Jhat, vus, outvolume, outrect, marginalCIs, deltas, TC123, covdeltas, cutoffs, covdeltas_plot]=fbcegg(x1or,x2or,x3or)
%[Jhat, vus, outvolume, outrect, marginalCIs, deltas, TC123, covdeltas, cutoffs, covdeltas_plot]=fdeltaegg(x1or,x2or,x3or)
TC123=[TC1hat TC2hat TC3hat];
TCs=TC123
CITC=[TCI1;TCI2;TCI3];
% TCI1=normcdf(TCI1inv)
% TCI2=normcdf(TCI2inv)
% TCI3=normcdf(TCI3inv)
%CITC=marginalCIs
FCs=[F21; 
     F31;
     F12;
     F32;
     F13;
     F23;]
%  
% CITC=[TC1 low upp;
%       TC2 low upp;
%       TC3 low upp;]
subplot(2,4,[3:4 7:8])
radarrates(FCs,TCs, CIFC, CITC)
%axis square

y=[x1;x2;x3];
gr=min(y):0.1:max(y);
[c1 c2]=meshgrid(gr,gr);

c1(c1>=c2)=NaN;
c2(c1>=c2)=NaN;
%TC1=normcdf((c1-m1hat)./s1hat);
%FC21=normcdf((c2-m1hat)./s1hat)-normcdf((c2-m2hat)./s2hat);
%FC31=1-normcdf((c2-m1hat)./s1hat);

subplot(2,4,1)



%----Estimate the two thresholds based on binormality:
c1hat=chat(1);
c2hat=chat(2);

%Monte Carlo estimates of deltas
delta1 = norminv(TC1hat);
delta2 = norminv(TC2hat);
delta3 = norminv(TC3hat);

delta1hat=delta1 ;
delta2hat=delta2 ;
delta3hat=delta3 ;
%-----------------------------------
covdeltas_plot=cov([norminv(TC1b) norminv(TC3b) norminv(TC2b)]);
invcovdeltas=inv(covdeltas_plot);
[U D V]=svd(invcovdeltas);

C=[(delta1hat) (delta3hat) (delta2hat)]';
[K1 K2 K3 SS]=myellipsoid(invcovdeltas, C, 20);
alpha(0.5)
xlabel('TC_{1}')
ylabel('TC_{3}')
zlabel('TC_{2}')
hold on
plot3(TCs(1),TCs(3),TCs(2),'*r','LineWidth',6)
grid on
box on

plot3(TCs(1),TCs(3),0,'*b','LineWidth',2)
plot3(TCs(1),0,TCs(2),'*b','LineWidth',2)
plot3(0,TCs(3),TCs(2),'*b','LineWidth',2)

%plot3([TCs(1),TCs(3),0],[TCs(1),TCs(3),TCs(2)])
plot3([TCs(1),TCs(1)],[TCs(3),TCs(3)],[0,TCs(2)])
plot3([0,TCs(1)],[TCs(3),TCs(3)],[TCs(2),TCs(2)])
plot3([TCs(1),TCs(1)],[0,TCs(3)],[TCs(2),TCs(2)])


%=====SIMULATION RESULTS==========


coverTC1(epan)=(TCI1(1)<TC1true & TC1true<TCI1(2));widTC1(epan)=max(TCI1)-min(TCI1);
coverTC2(epan)=(TCI2(1)<TC2true & TC2true<TCI2(2));widTC2(epan)=max(TCI2)-min(TCI2);
coverTC3(epan)=(TCI3(1)<TC3true & TC3true<TCI3(2));widTC3(epan)=max(TCI3)-min(TCI3);

coverFC21(epan)=(CI21(1)<  FC21true  &  FC21true     <CI21(2));widFC21(epan)=max(CI21)-min(CI21);
coverFC31(epan)=(CI31(1)<  FC31true  &  FC31true     <CI31(2));widFC31(epan)=max(CI31)-min(CI31);
coverFC12(epan)=(CI12(1)<  FC12true  &  FC12true     <CI12(2));widFC12(epan)=max(CI12)-min(CI12);
coverFC32(epan)=(CI32(1)<  FC32true  &  FC32true     <CI32(2));widFC32(epan)=max(CI31)-min(CI31);
coverFC13(epan)=(CI13(1)<  FC13true  &  FC13true     <CI13(2));widFC13(epan)=max(CI13)-min(CI13);
coverFC23(epan)=(CI23(1)<  FC23true  &  FC23true     <CI23(2));widFC23(epan)=max(CI23)-min(CI23);

xegg1;yegg1;
coveregg1(epan)=inpolygon(F21true,F31true,xegg1, yegg1);
coveregg2(epan)=inpolygon(F12true,F32true,xegg2, yegg2);
coveregg3(epan)=inpolygon(F13true,F23true,xegg3, yegg3);

current_coveregg1=mean(coveregg1);
current_coveregg2=mean(coveregg2);
current_coveregg3=mean(coveregg3);

areaegg1(epan)= polyarea(xegg1,yegg1)
areaegg2(epan)= polyarea(xegg2,yegg2)
areaegg3(epan)= polyarea(xegg3,yegg3)

epan=epan+1;
end

final_coverTC1=mean(coverTC1)
final_coverTC2=mean(coverTC2)
final_coverTC3=mean(coverTC3)

final_coverFC21=mean(coverFC21)
final_coverFC31=mean(coverFC31)

final_coverFC12=mean(coverFC21)
final_coverFC32=mean(coverFC31)

final_coverFC13=mean(coverFC13)
final_coverFC23=mean(coverFC23)


final_coveregg1=mean(coveregg1)
final_coveregg2=mean(coveregg2)
final_coveregg3=mean(coveregg3)

widthTC1=mean(widTC1);
widthTC2=mean(widTC2);
widthTC3=mean(widTC3);

widthFC21=mean(widFC21);
widthFC31=mean(widFC31);

widthFC12=mean(widFC12);
widthFC32=mean(widFC32);

widthFC13=mean(widFC13);
widthFC23=mean(widFC23);



aaa_out_results=[final_coverTC1;
                 final_coverTC2;
                 final_coverTC3;
                 final_coverFC21;
                 final_coverFC31;
                 final_coverFC12;
                 final_coverFC32;
                 final_coverFC13;
                 final_coverFC23;
                 final_coveregg1;
                 final_coveregg2;
                 final_coveregg3;
                 widthTC1;
                 widthTC2;
                 widthTC3;
                 widthFC21;
                 widthFC31;
                 widthFC12;
                 widthFC32;
                 widthFC13;
                 widthFC23;
                 mean(areaegg1);
                 mean(areaegg2);
                 mean(areaegg3);]'
