function [y1 y2 y3 creal m1 m2a m2b m3 s1 s2a s2b s3 F1 F2 F3]=generate_mix3d(J,n1,n2,n3)
   %close all  
   J=0.6
m1=3;s1=4;
y1=gamrnd(m1,s1,n1,1);
if J==0.4
m3=20;s3=1;n3=n2; %J=0.4
elseif J==0.6
m3=23.28;s3=3;n3=n2; %J=0.8
elseif J==0.8
m3=29;s3=2.7;n3=n2; %J=0.8
else
    error('J can be 0.4, 0.6 or 0.8');
end
    
y3=normrnd(m3,s3,n3,1);
m2=16.7;creal=11.3732;
    
F1=@(x) gamcdf(x,m1,s1);
s2a=1.32;s2b=sqrt(5);

s3a=3.5;s3b=4.5;
m2a=m2;m2b=m2+4;
m3a=m2+4;m3b=m2+13.35;

if J==0.4
m2a=m2-7;m2b=m2-1;
m3=17.2;s3=2.7
end    
F2=@(x) 0.5*normcdf(x,m2a,s2a)+0.5*normcdf(x,m2b,s2b);
%F3=@(x) normcdf(x,m3,s3);
F3=@(x) 0.5*normcdf(x,m3a,s3a)+0.5*normcdf(x,m3b,s3b);


Jh=@(g) -0.5*(F1(g(1))-F2(g(1))+F2(g(2))-F3(g(2)));
[creal J]=fminsearch(Jh,[11 13])


y2=zeros(n2,1);
for i=1:n2
    u=rand;
    if u<0.5
        y2(i)=normrnd(m2a,s2a,1,1);
    else
        y2(i)=normrnd(m2b,s2b,1,1);
    end
end

for i=1:n3
    u=rand;
    if u<0.5
        y3(i)=normrnd(m3a,s3a,1,1);
    else
        y3(i)=normrnd(m3b,s3b,1,1);
    end
end

 
 
 gr=0:0.01:40;
 plot(gr,gampdf(gr,m1,s1));maxx=max(gampdf(gr,m1,s1));
 hold on
 plot(gr,0.5*normpdf(gr,m2a,s2a)+0.5*normpdf(gr,m2b,s2b),'g')
 plot(gr,0.5*normpdf(gr,m3a,s3a)+0.5*normpdf(gr,m3b,s3b),'r')

% plot(gr,normpdf(gr,m3,s3),'r')
 plot(linspace(creal(1),creal(1),100),linspace(0,maxx,100),'b')
 plot(linspace(creal(2),creal(2),100),linspace(0,maxx,100),'r')

end