

close all
clear all
clc

%200, 5-6-7 super!
%100, 5-6-7
epan=1;
tic
warn=0;
aa=0;
while epan<=1
    aa=aa+1;
    rand('twister', 5493+aa);
      randn('state', 3+aa);
      randn('seed',3+aa);
      rand('seed',3+aa);

    epan
    close all
    
    
n=200000;n1=n;n2=n;n3=n;
%n1=50;n2=100;n3=200;
%J=0.6;Jreal=J;
n1=n;n2=n;n3=n;
a1=2;b1=0.5;
%a2=2.8225;b2=0.5;   %difference of 0.00
%a2=2.7346;b2=0.5; %difference of 0.05
%a2=2.6464;b2=0.5; %difference of 0.10
%a2=2.5579;b2=0.5; %difference of 0.15
a2=2.4685;b2=0.5; %difference of 0.20

a3=3.645;b3=0.5;

x1=lognrnd(a1,b1,n1,1);
x2=lognrnd(a2,b2,n2,1);
x3=lognrnd(a3,b3,n3,1);
F1=@(x) logncdf(x,a1,b1);
F2=@(x) logncdf(x,a2,b2);
F3=@(x) logncdf(x,a3,b3);
f1=@(x) lognpdf(x,a1,b1);
f2=@(x) lognpdf(x,a2,b2);
f3=@(x) lognpdf(x,a3,b3);

gr=0:0.01:40;
plot(gr,f1(gr),'b');hold on;
plot(gr,f2(gr),'g');
plot(gr,f3(gr),'r');


Jh=@(g) -0.5*(F1(g(1))-F2(g(1))+F2(g(2))-F3(g(2)));
[creal J]=fminsearch(Jh,[0.5*(mean(x1)+mean(x2)) 0.5*(mean(x2)+mean(x3))]);


%keep the original generated data at xors:
xor1=x1;xor2=x2;xor3=x3;
c1real=creal(1);
c2real=creal(2);
%Jreal=0.4;%0.5*(normcdf((c1real-m1)/s1)-normcdf((c1real-m2)/s2)+normcdf((c2real-m2)/s2)-normcdf((c2real-m3)/s3))
%Jreal
%break
true1=logncdf(c1real,a1,b1);
true2=logncdf(c2real,a2,b2)-logncdf(c1real,a2,b2);
true3=1-logncdf(c2real,a3,b3);


TC1true=true1;
TC2true=true2;
TC3true=true3;


FC21true=logncdf(c2real,a1,b1)-logncdf(c1real,a1,b1);
FC31true=1-logncdf(c2real,a1,b1);
FC12true=logncdf(c1real,a2,b2);
FC32true=1-logncdf(c2real,a2,b2);
FC13true=logncdf(c1real,a3,b3);
FC23true=logncdf(c2real,a3,b3)-logncdf(c1real,a3,b3);

F21true=FC21true;
F31true=FC31true;
F12true=FC12true;
F32true=FC32true;
F13true=FC13true;
F23true=FC23true;

F1true=[FC21true FC31true FC21true-FC31true]
F2true=[FC12true FC32true FC12true-FC32true]
F3true=[FC13true FC23true FC13true-FC23true]
FC12true-FC32true
%break
truedelta1=norminv(TC1true);
truedelta2=norminv(TC2true);
truedelta3=norminv(TC3true);

trueop=[true1 true2 true3];%this will change at the end since the actual point is true1, true3, true2
ROCsurf=@(p1,p3) (logninv(1-p3,m3,s3)>logninv(p1,m1,s1)).*(logncdf(logninv(1-p3,m3,s3),m2,s2)-...
      logncdf(logninv(p1,m1,s1),m2,s2));

  
%----Estimation Procedure:

n1=length(x1);n2=length(x2);n3=length(x3); %status1=zeros(n1,1);status2=zeros(n2,1);status3=zeros(n3,1);

[transx1, transx2, transx3, lam, exitflag]=boxcox3d(xor1,xor2,xor3)
x1=transx1;x2=transx2;x3=transx3;


%Monte Carlo
h1=0.9*min(std(x1),iqr(x1)/1.34)*length(x1)^(-0.2);
h2=0.9*min(std(x2),iqr(x2)/1.34)*length(x2)^(-0.2);
h3=0.9*min(std(x3),iqr(x3)/1.34)*length(x3)^(-0.2);

F1hat = @(at) ksdensity(x1,at,'function','cdf','width',h1);
F2hat = @(at) ksdensity(x2,at,'function','cdf','width',h2);
F3hat = @(at) ksdensity(x3,at,'function','cdf','width',h3);
% 
% F1hat=@(g) mykernel(x1,g);
% F2hat=@(g) mykernel(x2,g);
% F3hat=@(g) mykernel(x3,g);
init1=0.5*(mean(x1)+mean(x2));
init2=0.5*(mean(x2)+mean(x3));

Jhat=@(g) -0.5*(F1hat(g(1))-F2hat(g(1))+F2hat(g(2))-F3hat(g(2)));
[chat Jhat]=fminsearch(Jhat,[init1 init2])
c1hat=chat(1);
c2hat=chat(2);

TC1hat=F1hat(c1hat);
TC2hat=F2hat(c2hat)-F2hat(c1hat);
TC3hat=1-F3hat(c2hat);


F21 = F1hat(c2hat)-F1hat(c1hat);
F31 = 1-F1hat(c2hat);

F12 = F2hat(c1hat)
F32 = 1-F2hat(c2hat)

F13 = F3hat(c1hat)
F23 = F3hat(c2hat)-F3hat(c1hat);
%break
 %==========================
norminvF21 = norminv(F21);
norminvF31 = norminv(F31);
norminvF12 = norminv(F12);
norminvF32 = norminv(F32);
norminvF13 = norminv(F13);
norminvF23 = norminv(F23);

TC1hat= F1hat(c1hat);
TC2hat= F2hat(c2hat)-F2hat(c1hat);
TC3hat= 1-F3hat(c2hat);
%error("stop me")

%=================START BOOTSTRAP=============================
boots=1;
flag=0;
hmboots=0;
atboots=400;
break
while boots<=atboots && hmboots<atboots+atboots/2
    epan
    boots
hmboots=hmboots+1;
hmboots
    if epan>1
        outt_aa_epan_boots_hmboots_currentpower=[aa epan boots hmboots mean(power2)]
    end
at1=randsample(1:n1,n1,'true');   
at2=randsample(1:n2,n2,'true');
at3=randsample(1:n3,n3,'true');

x1orb=xor1(at1);
x2orb=xor2(at2);
x3orb=xor3(at3);

[transx1, transx2, transx3, lam, exitflag]=boxcox3d(x1orb,x2orb,x3orb);
x1b=transx1;x2b=transx2;x3b=transx3;
%x1b=x1orb;x2b=x2orb;x3b=x3orb;

h1b=0.9*min(std(x1b),iqr(x1b)/1.34)*length(x1b)^(-0.2);
h2b=0.9*min(std(x2b),iqr(x2b)/1.34)*length(x2b)^(-0.2);
h3b=0.9*min(std(x3b),iqr(x3b)/1.34)*length(x3b)^(-0.2);

F1b = @(at) ksdensity(x1b,at,'function','cdf','width',h1b);
F2b = @(at) ksdensity(x2b,at,'function','cdf','width',h2b);
F3b = @(at) ksdensity(x3b,at,'function','cdf','width',h3b);
   

%e1=normrnd(0,h1,n1,1);
%e2=normrnd(0,h2,n2,1);
%e3=normrnd(0,h3,n3,1);


%Monte Carlo
% F1b=@(g) mykernel(x1b,g);
% F2b=@(g) mykernel(x2b,g);
% F3b=@(g) mykernel(x3b,g);

if isa(F1b,'function_handle')==1 && isa(F2b,'function_handle')==1 && isa(F3b,'function_handle')==1
    
Jb=@(g) -0.5*(F1b(g(1))-F2b(g(1))+F2b(g(2))-F3b(g(2)));
init1=0.5*(mean(x1b)+mean(x2b));
init2=0.5*(mean(x2b)+mean(x3b));

[cb Jb]=fminsearch(Jb,[init1 init2])
c1b=cb(1);
c2b=cb(2);

F21b(boots) = F1b(c2b)-F1b(c1b);
F31b(boots) = 1-F1b(c2b);
F12b(boots) = F2b(c1b);
F32b(boots) = 1-F2b(c2b);
F13b(boots) = F3b(c1b);
F23b(boots) = F3b(c2b)-F3b(c1b);

TC1b(boots)= F1b(c1b);
TC2b(boots)= F2b(c2b)-F2b(c1b);
TC3b(boots)= 1-F3b(c2b);

FCb=[F21b(boots);F31b(boots);F12b(boots);F32b(boots);F13b(boots);F23b(boots)]
if min(FCb)>0 && max(FCb)<1
boots=boots+1;
end
end

if hmboots>atboots+atboots/2-1;flag=1;end

end

if flag==0
    
if size(F21b,1)==1;F21b=F21b';end
if size(F31b,1)==1;F31b=F31b';end
if size(F12b,1)==1;F12b=F12b';end
if size(F32b,1)==1;F32b=F32b';end
if size(F13b,1)==1;F13b=F13b';end
if size(F23b,1)==1;F23b=F23b';end

if size(TC1b,1)==1;TC1b=TC1b';end
if size(TC2b,1)==1;TC2b=TC2b';end
if size(TC3b,1)==1;TC3b=TC3b';end

fcinvall=[norminv(F21b) norminv(F31b) norminv(F12b) norminv(F32b) norminv(F13b) norminv(F23b)];
covinvall=cov([fcinvall]);

%=====END BOOTSTRAP=============================
VFC21=covinvall(1,1);
VFC31=covinvall(2,2);

VFC12=covinvall(3,3);
VFC32=covinvall(4,4);

VFC13=covinvall(5,5);
VFC23=covinvall(6,6);

covF21_F31=covinvall(1,2);
covF12_F32=covinvall(3,4);
covF13_F23=covinvall(5,6);

%Zstar1=(norminv(F21)-norminv(F31))/sqrt( VFC21 + VFC31 -2 * covF21_F31)
Zstar2=(norminv(F12)-norminv(F32))/sqrt( VFC12 + VFC32 -2 * covF12_F32);
%Zstar3=(norminv(F13)-norminv(F23))/sqrt( VFC13 + VFC23 -2 * covF13_F23)
%pval1=2*normcdf(-abs(Zstar1))
pval2=2*normcdf(-abs(Zstar2));
%pval3=2*normcdf(-abs(Zstar3))

%power1(epan)=(pval1<0.05)
power2(epan)=(pval2<0.05);
%power3(epan)=(pval3<0.05)



end

if flag==0
epan=epan+1;
end
end

             youneedthepower=mean(power2)