close all
clear all
clc

FCs=[0.8 0.3 0.5 0.7 0.9 1]
CI1=[0.7 0.9]
CI2=[0.6 0.9]
CI3=[0.5 0.9]
CI4=[0.3 0.9]
CI5=[0.9 1.0]
CI6=[0.4 0.9]
 
TCs=[0.7 0.8 0.4]
TCI1=[0.7 0.9]
TCI2=[0.7 0.9]
TCI3=[0.7 0.9]
 
     
x=0;y=0;r=1;
th=linspace(0, 2*pi, 10000);
xunit = r * cos(th) + x;
yunit = r * sin(th) + y;
plot(xunit, yunit,'--k','LineWidth',1)
axis square
hold on
plot(0,0,'ok','LineWidth',3)

x=0;y=0;r=0.8;
xunit = r * cos(th) + x;
yunit = r * sin(th) + y;
plot(xunit, yunit,'--k','LineWidth',1)
hold on


x=0;y=0;r=0.6;
xunit = r * cos(th) + x;
yunit = r * sin(th) + y;
plot(xunit, yunit,'--k','LineWidth',1)
hold on

x=0;y=0;r=0.4;
xunit = r * cos(th) + x;
yunit = r * sin(th) + y;
plot(xunit, yunit,'--k','LineWidth',1)
hold on

x=0;y=0;r=0.2;
xunit = r * cos(th) + x;
yunit = r * sin(th) + y;
plot(xunit, yunit,'--k','LineWidth',1)
hold on
xlim([-1.5 1.5])
ylim([-1.5 1.5])


txt1 = 'FC_{2|1}';
text(-0.7,0.9,txt1,'FontSize',15)
txt1 = 'FC_{3|1}';
text(-1.2,0,txt1,'FontSize',15)
txt1 = 'FC_{1|2}';
text(-0.7,-0.9,txt1,'FontSize',15)
txt1 = 'FC_{3|2}';
text(0.6,-0.9,txt1,'FontSize',15)
txt1 = 'FC_{1|3}';
text(1.05,0,txt1,'FontSize',15)
txt1 = 'FC_{2|3}';
text(0.55,0.89,txt1,'FontSize',15)



text(-0.07,-1.1,'TC_1','Color','red','FontSize',20)
text(-1.1,0.5,'TC_2','Color','red','FontSize',20)
text(0.9,0.5,'TC_3','Color','red','FontSize',20)


%true class rates:
  
 x=[0 TCs(1)];y=[0 0];
    [THETA,R] = cart2pol(x,y); %Convert to polar coordinates
    THETA=pi-0.47; %Add a_rad to theta
    %THETA=0.47; %Add a_rad to theta
    % THETA=-pi/2; %Add a_rad to theta
    [xr,yr] = pol2cart(THETA,R); %Convert back to Cartesian coordinates
    plot(xr,yr,'y','LineWidth',8);
 
      x=[TCI1(1) TCI1(2)];y=[0 0];
       [THETA,R] = cart2pol(x,y); %Convert to polar coordinates
        THETA=pi-0.47; %Add a_rad to theta
        [xr,yr] = pol2cart(THETA,R); %Convert back to Cartesian coordinates
        plot(xr(1),yr(1),'*r','LineWidth',1);
        plot(xr(end),yr(end),'*r','LineWidth',1);
        
  
    %=======================================================================
       hold on
 x=[0 TCs(2)];y=[0 0];
    [THETA,R] = cart2pol(x,y); %Convert to polar coordinates
    %THETA=pi-0.47; %Add a_rad to theta
    THETA=0.47; %Add a_rad to theta
    % THETA=-pi/2; %Add a_rad to theta
    [xr,yr] = pol2cart(THETA,R); %Convert back to Cartesian coordinates
    plot(xr,yr,'y','LineWidth',8);


        x=[TCI2(1) TCI2(2)];y=[0 0];
        [THETA,R] = cart2pol(x,y); %Convert to polar coordinates
        THETA=0.47; %Add a_rad to theta
        [xr,yr] = pol2cart(THETA,R); %Convert back to Cartesian coordinates
        plot(xr(1),yr(1),'*r','LineWidth',1);
        plot(xr(end),yr(end),'*r','LineWidth',1);
    
%=======================================================================

x=[0 TCs(3)];y=[0 0];
    [THETA,R] = cart2pol(x,y); %Convert to polar coordinates
    %THETA=pi-0.47; %Add a_rad to theta
    %THETA=0.47; %Add a_rad to theta
     THETA=-pi/2; %Add a_rad to theta
    [xr,yr] = pol2cart(THETA,R); %Convert back to Cartesian coordinates
    plot(xr,yr,'y','LineWidth',8);
   

        x=[TCI2(1) TCI2(2)];y=[0 0];
        [THETA,R] = cart2pol(x,y); %Convert to polar coordinates
        THETA=-pi/2; %Add a_rad to theta
        [xr,yr] = pol2cart(THETA,R); %Convert back to Cartesian coordinates
        plot(xr(1),yr(1),'*r','LineWidth',1);
        plot(xr(end),yr(end),'*r','LineWidth',1);

%=======================================================================

txt1 = '0.2';
text(-0.011,0.23,txt1)

txt1 = '0.4';
text(-0.011,0.43,txt1)

txt1 = '0.6';
text(-0.011,0.63,txt1)

txt1 = '0.8';
text(-0.011,0.83,txt1)

txt1 = '0.2';
text(-0.011,-0.23,txt1)

txt1 = '0.4';
text(-0.011,-0.43,txt1)

txt1 = '0.6';
text(-0.011,-0.63,txt1)

txt1 = '0.8';
text(-0.011,-0.83,txt1)





% x=[0 0.6];y=[0 sind(1*60)];
% plot(x,y,'r','LineWidth',2)
% x=[0 0.6];y=[0 0];
% hold on
% plot([0 0.6],[0 0],'r','LineWidth',2)
% plot([0 0.6],[0 sind(4*60)],'r','LineWidth',2)
% 
% plot([0 -0.6],[0 sind(1*60)],'r','LineWidth',2)
% plot([0 -0.6],[0 sind(3*60)],'r','LineWidth',2)
% plot([0 -0.6],[0 sind(4*60)],'r','LineWidth',2)
 set(gca,'xtick',[])
 set(gca,'ytick',[])

%============================
x=[0 FCs(1)];y=[0 0];
    [THETA,R] = cart2pol(x,y); %Convert to polar coordinates
    [xr,yr] = pol2cart(THETA,R); %Convert back to Cartesian coordinates
    plot(xr,yr,'g','LineWidth',2);hold on
    
    plot(CI1(1),0,'*r');plot(CI1(2),0,'*r');
%============================   
x=[0 FCs(2)];y=[0 0];
    [THETA,R] = cart2pol(x,y); %Convert to polar coordinates
    THETA=0.965; %Add a_rad to theta
    [xr,yr] = pol2cart(THETA,R); %Convert back to Cartesian coordinates
    plot(xr,yr,'k','LineWidth',2);
    
    x=[CI2(1) CI2(2)];y=[0 0];
     [THETA,R] = cart2pol(x,y); %Convert to polar coordinates
      THETA=0.965; %Add a_rad to theta
      [xr,yr] = pol2cart(THETA,R); %Convert back to Cartesian coordinates
      plot(xr(1),yr(1),'*r','LineWidth',1);
      plot(xr(end),yr(end),'*r','LineWidth',1);

%============================
x=[0 FCs(3)];y=[0 0];
    [THETA,R] = cart2pol(x,y); %Convert to polar coordinates
    THETA=0.965+1.211; %Add a_rad to theta
    [xr,yr] = pol2cart(THETA,R); %Convert back to Cartesian coordinates
    plot(xr,yr,'r','LineWidth',2);

     x=[CI3(1) CI3(2)];y=[0 0];
     [THETA,R] = cart2pol(x,y); %Convert to polar coordinates
      THETA=0.965+1.211; %Add a_rad to theta
      [xr,yr] = pol2cart(THETA,R); %Convert back to Cartesian coordinates
      plot(xr(1),yr(1),'*r','LineWidth',1);
      plot(xr(end),yr(end),'*r','LineWidth',1);

      %============================    
x=[0 FCs(4)];y=[0 0];
    [THETA,R] = cart2pol(x,y); %Convert to polar coordinates
    THETA=pi; %Add a_rad to theta
    [xr,yr] = pol2cart(THETA,R); %Convert back to Cartesian coordinates
    plot(xr,yr,'c','LineWidth',2);

     x=[CI4(1) CI4(2)];y=[0 0];
     [THETA,R] = cart2pol(x,y); %Convert to polar coordinates
      THETA=pi; %Add a_rad to theta
      [xr,yr] = pol2cart(THETA,R); %Convert back to Cartesian coordinates
      plot(xr(1),yr(1),'*r','LineWidth',1);
      plot(xr(end),yr(end),'*r','LineWidth',1);

%============================      
x=[0 FCs(5)];y=[0 0];
[THETA,R] = cart2pol(x,y); %Convert to polar coordinates
THETA=pi+0.97; %Add a_rad to theta
[xr,yr] = pol2cart(THETA,R); %Convert back to Cartesian coordinates
plot(xr,yr,'m','LineWidth',2);

     x=[CI5(1) CI5(2)];y=[0 0];
     [THETA,R] = cart2pol(x,y); %Convert to polar coordinates
      THETA=pi+0.97; %Add a_rad to theta
      [xr,yr] = pol2cart(THETA,R); %Convert back to Cartesian coordinates
      plot(xr(1),yr(1),'*r','LineWidth',1);
      plot(xr(end),yr(end),'*r','LineWidth',1);

  
%============================  
x=[0 FCs(6)];y=[0 0];
  [THETA,R] = cart2pol(x,y); %Convert to polar coordinates
   THETA=5.32; %Add a_rad to theta
   [xr,yr] = pol2cart(THETA,R); %Convert back to Cartesian coordinates
   plot(xr,yr,'b','LineWidth',2);


      x=[CI6(1) CI6(2)];y=[0 0];
      [THETA,R] = cart2pol(x,y); %Convert to polar coordinates
      THETA=5.32; %Add a_rad to theta
      [xr,yr] = pol2cart(THETA,R); %Convert back to Cartesian coordinates
      plot(xr(1),yr(1),'*r','LineWidth',1);
      plot(xr(end),yr(end),'*r','LineWidth',1);

 
    title('All possible estimated rates at the Youden index cutoffs along with their marginal 95% CIs depicted with red stars')  
    
    plot([0 0],[0 0],'ok','LineWidth',5)
    
    
    
    %%
%     close all
%     x = 0:.05:2*pi;
% y = sin(x);
% z = zeros(size(x));
% col = x;  % This is the color, vary with x in this case.
% surface([x;x],[y;y],[z;z],[col;col],...
%         'facecol','no',...
%         'edgecol','interp',...
%         'linew',6);